// Graphics2DView.h : interface of the CGraphics2DView class
//


#pragma once

typedef double MATRIX3X3[3][3];

typedef struct vector
{
    int x, y, w;
} VECTOR;

typedef struct shape
{
    int numVerts;
    VECTOR* vertices;
} SHAPE;

class CGraphics2DView : public CView
{
protected: // create from serialization only
	CGraphics2DView();
	DECLARE_DYNCREATE(CGraphics2DView)

// Attributes
public:
	CGraphics2DDoc* GetDocument() const;
protected:
    SHAPE m_polygon;
    VECTOR m_vectors[4];
    int m_rotate;
    double m_xScale, m_yScale;
    double m_xTranslate, m_yTranslate;

// Operations
public:

// Overrides
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// Implementation
public:
	virtual ~CGraphics2DView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
    void DrawShape(CDC* pDC, SHAPE& shape1);
    void Translate(MATRIX3X3& m, int xTrans, int yTrans);
    void Scale(MATRIX3X3& m, double xScale, double yScale);
    void Rotate(MATRIX3X3& m, int degrees);
    void Transform(SHAPE& shape, MATRIX3X3& m);
    void MultMatrix(MATRIX3X3& product,
        MATRIX3X3& matrix1, MATRIX3X3& matrix2);
    void InitMatrix(MATRIX3X3& m);
    void CopyMatrix(MATRIX3X3& dst, MATRIX3X3& src);

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
    afx_msg void OnTransformRotate();
    afx_msg void OnTransformScale();
    afx_msg void OnTransformTranslate();
    afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
};

#ifndef _DEBUG  // debug version in Graphics2DView.cpp
inline CGraphics2DDoc* CGraphics2DView::GetDocument() const
   { return reinterpret_cast<CGraphics2DDoc*>(m_pDocument); }
#endif

